#!/bin/bash
if [ $# -lt 1 ]
then
 echo "Usage: create_intance.sh instance_name"
 exit 1
fi

if [ -d /var/baycms/$1 ]
then
 echo "Instance $1 exists"
 exit 1
fi

mkdir -p /var/baycms/$1
cd /var/baycms/$1
chmod 755 /usr/share/doc/baycms/replace_from_to_for.pl
tar -xzf /usr/share/doc/baycms/baycms_base.tar.gz
/usr/share/doc/baycms/replace_from_to_for.pl /local/www/baycms_base /var/baycms/$1 ./
/usr/share/doc/baycms/replace_from_to_for.pl baycms_base $1 ./
cat /usr/share/doc/baycms/baycms_base.dmp.gz | gunzip > /tmp/$1.dmp
/usr/share/doc/baycms/replace_from_to_for.pl /local/www/baycms_base /var/baycms/$1 /tmp/$1.dmp
/usr/share/doc/baycms/replace_from_to_for.pl baycms_base $1 /tmp/$1.dmp


/bin/su - postgres -c "createuser $1"
/bin/su - postgres -c "createuser $1_extern"
/bin/su - postgres -c "createdb $1 -O $1"
/bin/su - postgres -c "psql -d $1 < /tmp/$1.dmp"

chown -R postgres:postgres /var/baycms/$1
chmod -R go-w /var/baycms/$1
chmod -R go+rX /var/baycms/$1
chown -R www-data /var/baycms/$1/tmp
cp /var/baycms/$1/inc/.htaccess /var/baycms/$1/tmp/
chown -R www-data /var/baycms/$1/file

echo "
<Directory /var/baycms/$1/>
  AllowOverride AuthConfig
  Require all granted
</Directory>

Alias /$1/de/ /var/baycms/$1/
Alias /$1/en/ /var/baycms/$1/
Alias /$1 /var/baycms/$1/top/gru

" > /etc/apache2/conf-available/baycms_$1.conf

a2enconf baycms_$1.conf
service apache2 reload

echo "

BayCMS instance $1 created. 

Please add

#Entry for baycms instance $1
local   $1  $1          trust
local   $1  $1_extern   trust

to your pg_hba.conf and run

/etc/init.d/postgresql reload

then try http://localhost/$1"



