create or replace function file_trigger() returns trigger as $$
# save: insert or update + mtime
# del: update + mtime
# move: update -mtime + name
die "Function is only usable in table file" if($_TD->{relname} ne "file");

use utf8;
my $save=0;
my $del=0;
my $move=0;
my $exitcode;
if($_TD->{event} eq "INSERT"){
  $save=1;
} elsif($_TD->{event} eq "UPDATE"){
  if($_TD->{old}{mtime} ne $_TD->{new}{mtime}){
    $del=1;
    $save=1;
  } elsif($_TD->{old}{name} ne $_TD->{new}{name}){
    $move=1;
  } else {
    return;
  }
} elsif($_TD->{event} eq "DELETE"){
  $del=1;
} else {
  return;
}

my $ziel;
my $quelle;
my $rv=spi_exec_query("select value as v from sysconfig where key in ('DOC_PFAD','FILE_PHP_POWER','FILE_UNZIP_POWER') order by key");
my $DOC_PFAD=$rv->{rows}[0]->{v};
die("no such directory $DOC_PFAD") if(! -d $DOC_PFAD);

my $PHP_POWER=$rv->{rows}[1]->{v};
my $UNZIP_POWER=$rv->{rows}[2]->{v};



if($del){
  $ziel=$_TD->{old}{name};
  if(-d "$DOC_PFAD/$ziel"){
    die("Trigger tried to delete $ziel") unless($ziel=~m|^[^/]+/[^/]+/?|g);
    system("rm -R '$DOC_PFAD/$ziel'");
  } else {
    system("rm '$DOC_PFAD/$ziel'");
  }
  die("Trigger could not delete File") if(-d "$DOC_PFAD/$ziel" || -e "$DOC_PFAD/$ziel");
}
  
my ($i,$pfad, $unzip);

if($save || $move ){
  $ziel=$_TD->{new}{name};
  $unzip=$_TD->{new}{unzip};
  my $usertype=$_TD->{new}{usertype};
  @_=split(/_/,$usertype);
  my $power=$_[1];
  die('Rights of user are not sufficient to unzip files') if($unzip && $UNZIP_POWER>$power);
  
  $ziel=~s|\.\./||g;
  $pfad=$ziel;

  $pfad=~s|[^/]*$||g;
  $ziel=~m|[^/]*$|g;
  $ziel=$&;

  die('Rights of user are not sufficient to save php files') if($ziel=~m|\.php\d?$| && $PHP_POWER>$power);
  	
  @_=split(/\//,$pfad);
  $pfad=$DOC_PFAD;
  for($i=0;$i<=$#_;$i++){
    $pfad.="/".$_[$i];
    die("Could not create $pfad (mkdir -p -m 0755 '$pfad')") if (system("mkdir -p -m 0755 '$pfad'"));
  } 


}

if($save){
  $quelle=$_TD->{new}{quelle};
   
  if($unzip) {
    die("mkdir $pfad/$ziel failed") if (system( "mkdir -p -m 0755 '$pfad/$ziel'"));
    $exitcode=system("/usr/bin/unzip '$quelle' -d '$pfad/$ziel'");
    if ($exitcode == -1) {
      die("failed to execute: $!");
    } elsif ($exitcode & 127) {
      $exitcode &=127;
      die("child died with signal $exitcode\n");
    } elsif(($exitcode>>8)>1) {
      $exitcode >>=8;
      die("child exited with code $exitcode\n");
    }
  } else {
    die("Copy failed $quelle $pfad/$ziel") if (system("cp '$quelle' '$pfad/$ziel'"));	
  }
  die("chmod $pfad failed") if (system("chmod -R go+rX '$pfad/$ziel'"));
}


if($move){
  $quelle=$_TD->{old}{name};
  die("move $DOC_PFAD/$quelle $pfad/$ziel failed") if(system("mv '$DOC_PFAD/$quelle' '$pfad/$ziel'"));
} 
return;
  
$$ language plperlu;


